<?php 
class exclusive_categ extends WP_Widget
{
    function exclusive_categ(){
		$widget_ops = array('description' => __('Displays Categories Posts','mottomag'));
		$control_ops = array('width' => '', 'height' => '');
		parent::WP_Widget(false,$name=__('Categories Posts','mottomag'),$widget_ops,$control_ops);
	}

  /* Displays the Widget in the front-end */
    function widget($args, $instance){
		extract($args);
		$title =  esc_html( $instance['title']);
		$categ_id = empty( $instance['categ_id'] ) ? '' : $instance['categ_id'];
		$post_count = empty( $instance['post_count'] ) ? '' : $instance['post_count'];
		
		$categ_id = (array) json_decode(stripslashes($categ_id));

		echo $before_widget;

		if ( $title )
			echo $before_title . $title . $after_title; ?>
		
        <style>	
		
		 .cat_widget_images{
		     height:<?php echo ($post_count*60).'px'; ?>;
		 }
		 .phone .cat_widget_images{
		     height:<?php echo ($post_count*160).'px'; ?>;
		 }
		 .cat_widget_images  > .cat_widget_image:hover{
			height:<?php echo ($post_count*60).'px'; ?> !important;
		 }
		 .phone .cat_widget_images  > .cat_widget_image:hover{
			height:160px !important;
		 }
		 .cat_widg p {
			margin: 0 0 13px !important;
         }
		 .cat_widg {
            padding-bottom: 10px;
			margin-bottom: 5px;
            border-bottom: 1px solid #ededed;
			float: left;
			width: 100%;
         }			
         .widget_exclusive_categ div:last-child div{
		    border-bottom:none !important;
         } 
         .cat_widg_cont {		 		  
           width: 100%;
		 }
		 .cat_widg_cont h3{
		   font-size: 19px !important;
		   margin-top: 0;
           line-height: 15px;
           margin-bottom: 8px !important;
		 }
		 .cat_widg_cont h3 a{
		   font-size:19px !important;
		 }
		 .widget-title{
		   margin-bottom: 0;
		 }
		 .cat_widg-img{
		    width: 75px;
			height: 70px;
			float: left;
			overflow: hidden;
			margin: 0 10px 10px 0 !important;

		}
        </style>		
		<?php	global $mottomag_general_settings_page;
		foreach ($mottomag_general_settings_page->options_generalsettings as $value) {
			if ( isset($value['var_name']) ) {
				$$value['var_name'] = $value['std'];
			}
		}
		if(!isset($post_count))
			$post_count =1;		
		$top_tabs_categorys=array();
		
		foreach( $categ_id as $key => $user_selected_categorie ) {						
			if(get_category($user_selected_categorie)!=NULL){ 
				$top_tabs_categorys[$key]['category_name']=get_category($user_selected_categorie)->name;				
				$top_tabs_categorys[$key]['query']='&posts_per_page='.$post_count.'&cat='.$user_selected_categorie.'&order=DESC';
				$top_tabs_categorys[$key]['cat_id']=$user_selected_categorie;
			}	
		}
		

		foreach ( $top_tabs_categorys as $key => $top_tabs_category ) { 
			if ( $top_tabs_category['cat_id']!=0 ) { ?>
				<div class="cat_widget <?php echo $key; ?>">								
					<h3 class="cat_widget_title">
					   <a href="<?php echo home_url(); ?>/?cat=<?php echo $top_tabs_category['cat_id']; ?>"><?php echo $top_tabs_category['category_name']; ?></a>
					</h3>																							 <a href="<?php echo home_url(); ?>/?cat=<?php echo $top_tabs_category['cat_id']; ?>">							 							
					<div class="cat_widget_images">							
						<?php  $post = query_posts($top_tabs_category['query']);
						if ( have_posts() ) : while ( have_posts() ) : the_post();
							 if(has_post_thumbnail()) { ?>	
								<div class="cat_widget_image">						 
								<?php if($grab_image && !has_post_thumbnail()) 
									{
										echo mottomag_display_thumbnail(250,230); 
									}
									else 
									{
									   echo mottomag_thumbnail(250,230);
									} ?>
								</div>	
							<?php }	
						   endwhile;
						endif;	
						wp_reset_postdata(); ?>
						<div class="clear"></div>
				   </div> </a>  
			   </div>			
			<?php	}
			}
		   wp_reset_query(); 
        echo '<div class="clear"></div>';   		   
		echo $after_widget;
				
		}

  /*Saves the settings. */
    function update($new_instance, $old_instance){
		
		$instance = $old_instance;
		$instance['title'] = sanitize_text_field( $new_instance['title'] );
		$instance['categ_id'] = wp_filter_post_kses( addslashes($new_instance['categ_id']));
		$instance['post_count'] = wp_filter_post_kses( addslashes($new_instance['post_count']));

		return $instance;
		
		}

  /*Creates the form for the widget in the back-end. */
    function form($instance){
				//Defaults
		$instance = wp_parse_args( (array) $instance, array( 'title'=>'Categories Posts', 'categ_id'=>'0', 'post_count'=>'3' ) );

		$title = esc_attr( $instance['title'] );
		$categ_id =   $instance['categ_id']; 
        $post_count = esc_attr( $instance['post_count'] );
		$categ_id =  (array) json_decode(stripslashes($categ_id)); 

		$widget_count=$this->number;

        if($widget_count){
		?>
		<script>
			function create_select(add_cat){
				var Select_options_sp=jQuery('.select_cat_for_home').eq(0).html();
				if(jQuery('.list_'+add_cat).length>1)
					jQuery('.list_'+add_cat).eq(1).append('<select class="select_cat_for_home" onchange="if_last_add_refresh_input('+add_cat+')" >'+Select_options_sp+'</select>').append(jQuery('.remov_img').eq(0).clone()).append('<div style="clear:both"></div>');
				else
				    jQuery('.list_'+add_cat).eq(0).append('<select class="select_cat_for_home" onchange="if_last_add_refresh_input('+add_cat+')" >'+Select_options_sp+'</select>').append(jQuery('.remov_img').eq(0).clone()).append('<div style="clear:both"></div>');
				if_last_add_refresh_input(add_cat);	
			} 		
			function if_last_add_refresh_input(add_cat){			
				var selected_categories={}
				var sp_coount_select=1;
				if(jQuery('.list_'+add_cat).length>1){
					jQuery('.list_'+add_cat).eq(1).find('.select_cat_for_home').each(function(index, element) {						
						selected_categories[''+sp_coount_select+'']=jQuery(this).val();	
						sp_coount_select++;		 
					});
					jQuery('.categ_id_'+add_cat).eq(1).val(JSON.stringify(selected_categories));					
				}else{	
				    jQuery('.list_'+add_cat).eq(0).find('.select_cat_for_home').each(function(index, element) {						
						selected_categories[''+sp_coount_select+'']=jQuery(this).val();	
						sp_coount_select++;		 
					});
					jQuery('.categ_id_'+add_cat).eq(0).val(JSON.stringify(selected_categories));
			    }
			}					
			function sp_remove_select_element(element,remove_element){
			    if(jQuery('.list_'+remove_element).length>1){				
					if(jQuery('.list_'+remove_element).eq(1).find('.remov_img').length>1){
						jQuery(element).prev().remove();
						jQuery(element).next().remove();
						jQuery(element).remove();
					}
				}else{
					if(jQuery('.list_'+remove_element).eq(0).find('.remov_img').length>1){
						jQuery(element).prev().remove();
						jQuery(element).next().remove();
						jQuery(element).remove();
					}
				}	
				if_last_add_refresh_input(remove_element);
			}
		</script>
       <?php  } ?>
	    <style>	
		 .select_cat_for_home {
			float:left;
         }
        </style>	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php echo __('Title:','mottomag'); ?></label><input class="widefat" id="<?php echo  $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>
		<p><label for="<?php echo $this->get_field_id('post_count'); ?>"><?php echo __('Number of Posts:','mottomag'); ?></label><input id="<?php echo  $this->get_field_id('post_count'); ?>" name="<?php echo $this->get_field_name('post_count'); ?>" type="text" value="<?php echo $post_count; ?>" size="6"/></p>
		<div class="list_<?php echo  $widget_count; ?>">
		<?php $categorys=get_categories('hide_empty=0');
		if(count($categ_id)>=1){
			foreach($categ_id as $user_selected_categorie){
			?>			
			<select onchange="if_last_add_refresh_input('<?php echo  $widget_count; ?>')" class="select_cat_for_home" >
				<?php foreach($categorys as $category) {?>
				<option <?php selected($user_selected_categorie,$category->cat_ID); ?>  value="<?php echo $category->cat_ID ?>"><?php echo $category->name ?></option>
				<?php } ?>
			</select>	<img onclick="sp_remove_select_element(this,'<?php echo  $widget_count; ?>')"  class="remov_img" src="<?php echo get_template_directory_uri().'/images/delete_el_hover.png'; ?>" />
			<div style="clear:both"></div>
			<?php } 
		} else {?>
			<select onchange="if_last_add_refresh_input('<?php echo  $widget_count; ?>')" class="select_cat_for_home" >
				<?php foreach($categorys as $category) {?>
				<option <?php selected($categ_id,$category->cat_ID); ?>  value="<?php echo $category->cat_ID ?>"><?php echo $category->name ?></option>
				<?php } ?>
			</select>	<img onclick="sp_remove_select_element(this,'<?php echo  $widget_count; ?>')"  class="remov_img" src="<?php echo get_template_directory_uri().'/images/delete_el_hover.png'; ?>" />	<div style="clear:both"></div>		
		<?php } ?>
		</div>
		<input type="button" value="Add Category" onclick="create_select('<?php echo  $widget_count; ?>')" />
		<input type="hidden" class="categ_id_<?php echo $widget_count; ?>" name="<?php echo $this->get_field_name('categ_id'); ?>" value='<?php echo stripslashes($instance['categ_id']); ?>' />

<?php	

}

}// end exclusive_categ class
add_action('widgets_init', create_function('', 'return register_widget("exclusive_categ");'))
?>