<?php



class mottomag_slider_page_class{

	public $homepage;
	public $shorthomepage;
		

	function __construct(){
		$this->homepage = "Homepage";
		$this->shortslider = "";
		
		
		$value_of_std[0]=get_theme_mod($this->shortslider."_image_height",'365');
		$value_of_std[1]=get_theme_mod($this->shortslider."_animation_speed",'800');
		$value_of_std[2]=get_theme_mod($this->shortslider."_slideshow_interval",'5000');
		$value_of_std[3]=get_theme_mod($this->shortslider."_stop_on_hover",'');
		$value_of_std[4]=get_theme_mod($this->shortslider."_effect",'random');
		$value_of_std[6]=get_theme_mod($this->shortslider."_description_position",'left');
		$value_of_std[7]=get_theme_mod($this->shortslider."_imgs_url",'{"0":"'.get_template_directory_uri("template_url").'/images/slide_1.jpg","1":"'.get_template_directory_uri("template_url").'/images/slide_2.jpg"}');
		$value_of_std[8]=get_theme_mod($this->shortslider."_imgs_href",'');
		$value_of_std[10]=get_theme_mod($this->shortslider."_imgs_description",'{"0":"<p class=\"custom-slider\">Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec eu libero sit amet quam egestas semper.</p>","1":"<p class=\"custom-slider\">Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec eu libero sit amet quam egestas semper.</p>"}');
		
		$this->options_slider = array(
		
		
			"image_height" => array(
			
				"name" => __("Slider Height","mottomag"),
				
				"description" => __("The height of the slider can be customized. You need to specify the height in the box provided.","mottomag"),
				
				"var_name" => "image_height",

				"id" => $this->shortslider."_image_height",

				"std" => $value_of_std[0]
			
			),
			
			"animation_speed" => array(
			
				"name" => __("Animation Speed","mottomag"),
				
				"description" => __("When using an animation for the slider, you can control its speed. You can use the provided box to fill in the optimal speed.","mottomag"),
				
				"var_name" => "animation_speed",

				"id" => $this->shortslider."_animation_speed",

				"std" => $value_of_std[1]
			
			),
			
			"slideshow_interval" => array(
			
				"name" => __("Pause Time","mottomag"),
				
				"description" => __("The timing for the slider animation can be customized. You can adjust it providing timing in the corresponding box.","mottomag"),
				
				"var_name" => "slideshow_interval",

				"id" => $this->shortslider."_slideshow_interval",

				"std" => $value_of_std[2]
			
			),
			
			
			"stop_on_hover" => array(
			
				"name" => __("Stop animation while hovering","mottomag"),
				
				"description" => __("By default slider animation is constant. However you can choose it to stop while hovering, checking the box for this option.","mottomag"),
				
				"var_name" => "stop_on_hover",

				"id" => $this->shortslider."_stop_on_hover",

				"std" => $value_of_std[3]
			
			),
						
			"effect" => array(
			
				"name" => __("Effect","mottomag"),
			
				"description" => __("The animation of the slider can be customized with the help of various effects. You can choose the slider animation effect from the list included below.","mottomag"),
				
				"var_name" => "effect",
				
				"all_values" => array(
					"none" => "None",
					"cubeH"  =>  "Cube Horizontal",
					"cubeV"  =>  "Cube Vertical",
					"fade"  =>  "Fade",
					"sliceH"  =>  "Slice Horizontal",
					"sliceV"  =>  "Slice Vertical",
					"slideH"  =>  "Slide Horizontal",
					"slideV"  =>  "Slide Vertical",
					"scaleOut"  =>  "Scale Out",
					"scaleIn"  =>  "Scale In",
					"blockScale"  =>  "Block Scale",
					"kaleidoscope"  =>  "Kaleidoscope",
					"fan"  =>  "Fan",
					"blindH"  =>  "Blind Horizontal",
					"blindV"  =>  "Blind Vertical",
					"random"  =>  "Random"		
				
				),

				"id" => $this->shortslider."_effect",

				"std" => $value_of_std[4]
			
			),
			
			"description_position" => array(
			
				"name" => __("Description Position","mottomag"),
				
				"description" => "",
				
				"var_name" => "description_position",

				"id" => $this->shortslider."_description_position",

				"std" => $value_of_std[6]
			
			),
			
			"imgs_url" => array(
			
				"name" => "",
				
				"all_values" => '',
				
				"description" => "",
				
				"var_name" => "imgs_url",

				"id" => $this->shortslider."_imgs_url",

				"std" => $value_of_std[7]
			
			),

			"imgs_href" => array(
			
				"name" => "",
				
				"description" => __("Specify the number of content posts which will be displayed in the homepage.","mottomag"),
				
				"var_name" => "imgs_href",

				"id" => $this->shortslider."_imgs_href",

				"std" => $value_of_std[8]
			
			),
			
			"imgs_description" => array(
			
				"name" => "",
				
				"description" => "",
				
				"var_name" => "imgs_description",

				"id" => $this->shortslider."_imgs_description",

				"std" => $value_of_std[10]
			
			),
						
			
			
		);
		
	}


	/// save changes or reset options

	public function mottomag_theme_update_slider(){
		if (isset($_GET['page']) &&  $_GET['page'] == "web_dorado_theme" && isset($_GET['controller']) && $_GET['controller'] == "slider_page") {

			if (isset($_REQUEST['action']) && $_REQUEST['action']=='save' ) {

				foreach ($this->options_slider as $value) {
					if(isset($_REQUEST[$value['var_name']]))
						set_theme_mod($value['id'], stripslashes($_REQUEST[$value['var_name']]));
				}
				foreach ($this->options_slider as $value) {
					if (isset($_REQUEST[$value['var_name']])) {
						set_theme_mod($value['id'], stripslashes($_REQUEST[$value['var_name']]));
					} else {
						remove_theme_mod($value['id']);
					}
				}
				header("Location: themes.php?page=web_dorado_theme&controller=home_page&saved=true");
				die;
			} 
			else {
				
				if (isset($_REQUEST['action']) && $_REQUEST['action']=='reset') {
					
					foreach ($this->options_slider as $value) {
						remove_theme_mod($value['id']);
					}
					header("Location: themes.php?page=web_dorado_theme&controller=home_page&reset=true");
					die;
				}
								
			}
		}

	
	
	}

	/// print massage after save

	private function mottomag_print_massage(){
		if (isset($_GET['saved']) && $_GET['saved'] =='saved'  ) 
			echo '<div id="message" class="updated"><p><strong>Slider settings are saved.</strong></p></div>';
		if (isset($_GET['reset']) && $_GET['reset'] == 'reset' ) 
			echo '<div id="message" class="updated"><p><strong>Slider settings are reset.</strong></p></div>';
	}

	

	/// include style and scripts for slider page

	public function mottomag_slider_page_admin_scripts(){
		wp_enqueue_style('color_control_page_main_style',get_template_directory_uri().'/admin/css/slider_page.css');	
		wp_enqueue_script('jquery');
		wp_enqueue_script( 'common' );
		wp_enqueue_script( 'jquery-color' );
		wp_print_scripts('editor');
		if (function_exists('add_thickbox')) add_thickbox();
		wp_print_scripts('media-upload');
		wp_admin_css();
		wp_enqueue_script('utils');
		do_action("admin_print_styles-post-php");
		do_action('admin_print_styles');
	}

	//// back end style

	public function mottomag_theme_admin_slider(){

		global $mottomag_admin_helepr_functions,$mottomag_web_dor;
		$imgs_url=json_decode ($this->options_slider['imgs_url']['std'],true);
		$imgs_href=json_decode ( $this->options_slider['imgs_href']['std'],true);
		$imgs_description=json_decode ( $this->options_slider['imgs_description']['std'],true);
		
		?>		
		<div id="main_slider_page">
			<div id="main_slider_div">
			 <div class="wrap" style="margin-right:76px; margin-left: 82px;">
		    	<table align="center" width="100%" style="margin-top: 0px;border-bottom: rgb(111, 111, 111) solid 2px;">
					<tr>   
					  <td style="font-size:14px; font-weight:bold;color: #333;">
						 <a href="<?php echo $mottomag_web_dor.'/wordpress-themes-guide-step-1.html'; ?>" target="_blank" style="outline-style: none !important;color:#126094; text-decoration:none;"><?php echo __("User Manual", "mottomag" ); ?></a><br /><?php echo __("This section allows you customize the slider.", "mottomag" ); ?>
						 <a href="<?php echo $mottomag_web_dor.'/wordpress-theme-options/3-8.html'; ?>" target="_blank" style="outline-style: none !important;color:#126094; text-decoration:none;"><?php echo __("More...", "mottomag" ); ?></a>
					 </td>   
					  <td  align="right" style="font-size:16px;">
						   <a href="<?php echo $mottomag_web_dor.'/wordpress-themes/mottomag.html'; ?>" target="_blank" style="outline-style: none !important; text-decoration:none;">
							  <img src="<?php echo get_template_directory_uri() ?>/images/header.png" border="0" alt="" width="215">
						   </a>
					   </td>
					</tr>
					<tr>
						<td>
							<h3 style="margin: 0px;font-family:Segoe UI;padding-bottom: 15px;color: rgb(111, 111, 111); font-size:18pt;font-weight: bold;"><?php echo __("Slider", "mottomag" ); ?></h3>
						</td>
					</tr>
				</table>
                <div class="wrap">
<form method="post" action="themes.php?page=web_dorado_theme&controller=slider_page&saved=saved">
<table class="optioninput" width="800">
    <tr>
		<td width="20%"  valign="middle">
        	<h3><?php echo $this->options_slider['image_height']['name'] ?><span class="hasTip" style="cursor: pointer;color: #3B5998;" title="<?php echo $this->options_slider['image_height']['description']  ?>.">[?]</span></h3></td>
		<td><input style="width:66px;" name="<?php echo $this->options_slider['image_height']['var_name'] ?>" id="<?php echo $this->options_slider['image_height']['id'] ?>" value="<?php echo $this->options_slider['image_height']['std'] ?>" /></td>
	</tr>
    <tr>
		<td width="20%"  valign="middle"><h3><?php echo $this->options_slider['animation_speed']['name'] ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="<?php echo $this->options_slider['animation_speed']['description'] ?>.">[?]</span></h3>
        </td>
		<td><input style="width:66px;" name="<?php echo $this->options_slider['animation_speed']['var_name'] ?>" id="<?php echo $this->options_slider['animation_speed']['var_name'] ?>" value="<?php echo $this->options_slider['animation_speed']['std'] ?>" /></td>
	</tr>
    <tr>
		<td width="20%"  valign="middle"><h3><?php echo $this->options_slider['slideshow_interval']['name'] ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="<?php echo $this->options_slider['slideshow_interval']['name'] ?>">[?]</span></h3>
        </h3></td>
		<td><input style="width:66px;" name="<?php echo $this->options_slider['slideshow_interval']['var_name'] ?>" id="<?php echo $this->options_slider['slideshow_interval']['var_name'] ?>" value="<?php echo $this->options_slider['slideshow_interval']['std'] ?>" /></td>
	</tr>
	<tr>
		<td width="20%"  valign="middle"><h3><?php echo $this->options_slider['stop_on_hover']['name'] ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="<?php echo $this->options_slider['stop_on_hover']['description'] ?>">[?]</span>
        </h3></td>
		<td><input type="checkbox" name="<?php echo $this->options_slider['stop_on_hover']['var_name'] ?>" id="<?php echo $this->options_slider['stop_on_hover']['var_name'] ?>" value="true" <?php checked($this->options_slider['stop_on_hover']['std'], "true"); ?>></td>
	</tr>
	
	<tr>
		<td width="20%"  valign="middle"><h3><?php echo $this->options_slider['effect']['name'] ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="<?php echo $this->options_slider['effect']['description'] ?>">[?]</span>
        </h3></td>
		<td>
			<select style="width:215px;" name="<?php echo $this->options_slider['effect']['var_name'] ?>" id="<?php echo $this->options_slider['effect']['var_name'] ?>">
				
				<?php foreach($this->options_slider['effect']['all_values'] as $key => $value){ ?>
                	<option <?php selected($key,$this->options_slider['effect']['std']) ?> value="<?php echo $key; ?>"><?php echo $value; ?></option>
                <?php } ?>
			</select>
		</td>
	</tr>	
    
	<tr>
		<td width="20%"  valign="middle"><h3><?php echo __("Description Position", "mottomag" ); ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="Set the position of the image description in the slider.">[?]</span>
        </h3></td>
		<td>
			<table class="bws_position_table">
				<tbody>
				  <tr>
					<td>
						<select style="width:215px;" name="<?php echo $this->options_slider['description_position']['var_name'] ?>"> 
						    <option value="left" <?php selected($this->options_slider['description_position']['std'], "left"); ?>><?php echo __("Left", "mottomag" ); ?></option>
						    <option value="right" <?php selected($this->options_slider['description_position']['std'], "right"); ?>><?php echo __("Right", "mottomag" ); ?></option>
						</select>					
					</td>
				  </tr>				  
				</tbody>
		  </table>
		</td>
	</tr> 
   <?php  if(!(count($imgs_url)==1 && $imgs_url[0]=='')) for($i=0;$i<count($imgs_url);$i++){ ?>
	<tr class="slide-from-base">
    	<td width="20%" valign="middle">
        	<h3><?php echo $this->options_slider['imgs_url']['name'] ?></h3>
        </td>
        <td>
        	<input size="36" value="<?php echo $imgs_url[$i]; ?>" class="upload image_links_group" id="ct_image_link_<?php echo $i ?>" name="ct_image_link_<?php echo $i ?>" />
            <input type="submit" class="update-button" value="Update image"><input class="remove-image" value="Remove image" type="submit" />
        </td>
    </tr>
    <tr rel="<?php echo $i ?>"><td width="20%" valign="middle"><h3></h3></td><td><img  src="<?php echo $imgs_url[$i]; ?>" /></td></tr>
    <tr>
    	<td width="20%" valign="middle"><h3><?php echo __("Image Href", "mottomag" ); ?></h3></td>
        <td><input  type="text" name="ct_image_href_<?php echo $i ?>" class="image_href_group" value="<?php echo $imgs_href[$i]; ?>" /></td>
    </tr>
    <tr>
    	<td width="20%"  valign="middle">
        	<h3><?php echo __("Image Description", "mottomag" ); ?></h3>
        </td>
        <td>
        	<textarea class="image_description_group" name="ct_image_textarea_<?php echo $i ?>"><?php echo $imgs_description[$i]; ?></textarea>
        </td>
    </tr>	
    
    <?php } ?>
	<tr id="add-image-line">
		<td width="20%"  valign="middle"><h3><?php echo __("Image", "mottomag" ); ?>
        <span class="hasTip" style="cursor: pointer;color: #3B5998;" title="Using this option you can add images for the slider.">[?]</span>
        </h3></td>
		<td><input class="upload-button" type="button" id="slides-img-add-button" value="Upload New Image" /></td>
	</tr>
</table>
	<p class="submit" style="float: left; margin-left: -22px; margin-right: 8px;">
		<input class="button" name="save" type="submit" value="Save changes" style="background: url(../../images/button.png) center; background-size: 100% 100%;" />
		<input type="hidden" name="action" value="save" />
       
        <input type="hidden" name="<?php echo $this->options_slider['imgs_url']['var_name'] ?>" id="image_links_group_id" value='<?php echo $this->options_slider['imgs_url']['std'] ?>'  />
        <input type="hidden" name="<?php echo $this->options_slider['imgs_href']['var_name'] ?>" id="image_href_group_id" value='<?php echo $this->options_slider['imgs_href']['std'] ?>'  />    
        <input type="hidden" name="<?php echo $this->options_slider['imgs_description']['var_name'] ?>" id="image_description_group_id" value='<?php echo $this->options_slider['imgs_description']['std'] ?>' />
</form>
<form method="post" action="themes.php?page=web_dorado_theme&controller=slider_page&reset=reset">
	<p class="submit"> 
		<input class="button" name="reset" type="submit" value="Reset"  style="background: url(../../images/button.png) center; background-size: 100% 100%;"/>
		<input type="hidden" name="action" value="reset" />
	</p>
</form>
</div>
</div>

<script type="text/javascript">

jQuery(document).ready(function(){ 
	
	 var j=jQuery('tr.slide-from-base').length;

	jQuery( ".image_links_group,.image_href_group,.image_title_group,.image_description_group" ).change(function() {
 		set_values_in_inputs();
	});
	
	jQuery('#main_slider_div .upload-button').click(function(){
		var button="add";
 		tb_show("", "media-upload.php?type=image&amp;TB_iframe=true");  
		add_image=send_to_editor ;
		
	window.send_to_editor = function(html) { 
		  imgurl = jQuery("img",html).attr("src");
		  var tr='<tr class="new"><td width="30%" valign="middle"><h3>Image</h3></td><td><input size="36" value="'+imgurl+'" class="upload image_links_group" id="ct_image_link_'+j+'" name="ct_image_link_'+j+'" /><input type="submit" class="update-button" value="Update image"><input class="remove-image" value="Remove image" type="submit" /></td></tr> <tr class="new" rel="'+j+'"><td width="30%" valign="middle"><h3></h3></td><td><img  src="'+imgurl+'" /></td></tr><tr class="new"><td width="30%" valign="middle"><h3>The URL of image when clicked</h3></td><td><input type="text" class="image_href_group" name="ct_image_href_'+j+'" value="" /></td></tr><tr class="new"><td width="30%"  valign="middle"><h3>Text on images</h3></td><td><textarea class="image_description_group" name="ct_image_textarea_'+j+'"></textarea></td></tr>';
		  jQuery("#add-image-line").before(tr);	
		  	jQuery( ".image_links_group,.image_href_group,.image_title_group,.image_description_group" ).change(function() {
				set_values_in_inputs();
			});

		  set_values_in_inputs();	
		  j++;
		  tb_remove();  
	  };
	  return false; 	
	});
	
	// add element
	jQuery(document).on("click" , ".update-button",  function(){
		var i=jQuery(this).parents("tr").next().attr("rel");
		var button="update";
		tb_show("", "media-upload.php?type=image&amp;TB_iframe=true");  	
	
		window.send_to_editor = function(html) { 
			updateurl = jQuery("img",html).attr("src"); 
			jQuery("#ct_image_link_"+i).attr("value",updateurl);
			jQuery("#ct_image_link_"+i).attr("name","ct_image_link_"+i);
			jQuery("tr[rel='"+i+"']").find("img").attr("src",updateurl);
			set_values_in_inputs();
			tb_remove();  
		};

		return false; 	
	});	

	// remove element
	jQuery(document).on("click" , ".remove-image",  function(){
		jQuery(this).parents("tr").next().next().next().next().remove();
		jQuery(this).parents("tr").next().next().next().remove();
		jQuery(this).parents("tr").next().next().remove();
		jQuery(this).parents("tr").next().remove();
		jQuery(this).parents("tr").remove();
		set_values_in_inputs();
		return false;
	});
	
});
function set_values_in_inputs(){
	var string_imgs_url ={};
	var string_imgs_href = {};
	var string_imgs_description = {};
	for ( var i = 0; i < jQuery('.image_links_group').length; i++ ) {
		string_imgs_url[i]=jQuery('.image_links_group').eq(i).val();
	}
	for ( var i = 0; i < jQuery('.image_href_group').length; i++ ) {
		string_imgs_href[i]=jQuery('.image_href_group').eq(i).val();	
	}
	for ( var i = 0; i < jQuery('.image_description_group').length; i++ ) {
		string_imgs_description[i]=jQuery('.image_description_group').eq(i).val();
	}
	jQuery('#image_links_group_id').val(JSON.stringify(string_imgs_url));
	jQuery('#image_href_group_id').val(JSON.stringify(string_imgs_href));
	jQuery('#image_description_group_id').val(JSON.stringify(string_imgs_description));
}
</script>        
        
         <div style="clear:both; width:100%"></div></div></div>  <?php

	}
}

 

