<?php 
global $post,$mottomag_general_settings_page;
	foreach ( $mottomag_general_settings_page->options_generalsettings as $value ) {
		if(isset($value['id'])){
			   $$value['var_name'] = $value['std']; 
		}
	}
get_header();
?>
 <div class="container">
	 <?php if ( is_active_sidebar( 'sidebar-1' ) ) { ?>
		<aside id="sidebar1">
			<div class="sidebar-container">
				<?php  dynamic_sidebar( 'sidebar-1' ); 	?>	
				<div class="clear"></div>
			</div>
		</aside>
	 <?php }  ?>
		<div id="content" class="blog search-page">
		   <div id="main-content">
				<div class="single-post">
					<h2 class="border-style">
						<?php echo __('Search','mottomag'); ?>
					</h2>
				</div>
				<form role="search" method="get" id="searchform" action="<?php echo esc_url(home_url('/')); ?>">
					<div id="searchbox">
							<input  type="text" id="searchinput" value="<?php echo get_search_query(); ?>" name="s" id="s" class="searchbox_search" placeholder="<?php echo __('Search','mottomag'); ?>"/> 
							<input type="submit" id="searchsubmit" value="" />
					 </div>
					 <div class="search-settings-block">
					<label  id="inc-posts" style="margin-right: 14px;"><input type="checkbox" name="inc-posts" <?php checked(isset($_GET['inc-posts']) && $_GET['inc-posts']=='on'); ?>/><?php echo __('Posts','mottomag'); ?></label>
					<label  id="inc-pages"  style="margin-right: 14px;"><input type="checkbox" name="inc-pages" <?php checked(isset($_GET['inc-pages']) && $_GET['inc-pages']=='on'); ?>/><?php echo __('Pages','mottomag'); ?></label>
					<?php
						if(isset($_GET['cat']))
						    $cat=$_GET['cat'];
						else   
						    $cat='';
					?>
					<div class="styled-select"><?php wp_dropdown_categories( 'show_option_all='.__('All Categories','mottomag').'&selected='.$cat.'' ); ?> </div>
					<div class="styled-select">
						<select style="margin-left:14px;" id="inc-month" name="month">
							<option value="no"><?php echo __('Select a month','mottomag'); ?></option>
							<?php   global $wpdb, $wp_locale;
							$selected = '';
							$query = "SELECT YEAR(post_date) AS `year`, MONTH(post_date) AS `month`, count(ID) as posts FROM $wpdb->posts GROUP BY YEAR(post_date), MONTH(post_date) ORDER BY post_date DESC";
							$arcresults = $wpdb->get_results($query);
							foreach ( (array) $arcresults as $arcresult ) 
							{
								echo "<option ".selected( isset($_GET['month']) && ( $_GET['month'] == ($arcresult->year . $arcresult->month) ) )." value='{$arcresult->year}{$arcresult->month}'{$selected}>{$wp_locale->get_month($arcresult->month)}" . ", {$arcresult->year}</option>";
								
							} ?>
						</select>
					</div>
				</div>
			</form>
			
			<?php /*print page content*/ 
			if( have_posts() ) { 
				while( have_posts()){ 
					the_post(); ?>
					 <div class="search-result">
						<h3>
							<a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
						</h3>
						
						<div class="entry">
							<?php if($blog_style){
								 the_excerpt();
							   }else{
								 the_content(__('More','mottomag'));
							   }  ?>
						</div>
					</div>
		  <?php } ?>
				   <div class="page-navigation">
						<?php posts_nav_link(); ?>
				   </div>
		   <?php } else {?>
				<div class="search-no-result">
			      <?php echo __(" Nothing was found. Please try another keyword.","mottomag");  ?>
				</div>
			<?php }
			wp_reset_query(); ?>
		</div>
		<?php if ( is_active_sidebar( 'sidebar-2' ) ) { ?>
			<aside id="sidebar2">
				<div class="sidebar-container">
				  <?php  dynamic_sidebar( 'sidebar-2' ); 	?>
				  <div class="clear"></div>
				</div>
			</aside>
		<?php } ?>
	<div class="clear"></div>		
   </div>
</div>
<?php get_footer(); ?>
